BQ=./Src
BMOD=/homes/sep/bob/Src/cpp/rtm/model.x
BMIG=/homes/sep/bob/Src/wei_good/S_G_wem.x


slice.H: ${BQ}/Qdome.x
	${BQ}/Qdome.x throw=.15  |Window3d f3=20 n3=1 >$@

vel.H:  ${BQ}/Qdome.x  ${BQ}/Qdome_v.x
	${BQ}/Qdome.x d2=.00125 n2=1600 throw=.03 ratio=.05  n1=400 |Window3d f3=20 n3=1  throw=.07 ratio=.3 |Scale dscale=1000 >dx.H
	echo o1=0 o2=0 d1=.012 d2=.0125 >> dx.H
	Math file1=dx.H >dens.H exp="((file1/3.8)+3)*2.5-4."
	${BQ}/Qdome_v.x d2=.00125 n2=1600 throw=.03 ratio=.05  n1=400 |Window3d f3=20 n3=1  throw=.07 ratio=.3 |Scale dscale=1000 >y.H
	echo o1=0 o2=0 d1=.012 d2=.0125 >> y.H
	Smooth < y.H  rect1=8 rect2=4 >f.H
	Math file1=f.H exp="file1/10000+1.35" >$@



wavelet.H: ${P}/wavelet.P
	Wavelet par=${P}/wavelet.P >tmp.H out=stdout 
	Window3d < tmp.H >x1.H n1=128
	echo d1=.004 >>x1.H
	Bandpass < x1.H >$@ fhi=50


# mod1.H: vel.H ${BMOD} wavelet.H ${P}/mod.P
# 	Pad < vel.H >v.H extend=1 beg1=20 beg2=20 end1=200 end2=20
# 	Pad < dx.H >d.H extend=1 beg1=20 beg2=20 end1=200 end2=20
# 	Add scale=1,0.1 v.H d.H >v2.H
# 	${BMOD} velocity=v2.H density=d.H wavelet=wavelet.H >$@ par=${P}/mod.P osrc=7.5 nsrc=1 range_x=12

mod1.H: vel.H ${BMOD} wavelet.H ${P}/mod.P
	Pad < vel.H >v.H extend=1 beg1=20 beg2=20 end1=150 end2=20
	Pad < dx.H >d.H extend=1 beg1=20 beg2=20 end1=150 end2=20
	Add scale=1,0.1 v.H d.H >v2.H
	${BMOd} velocity=v2.H density=d.H wavelet=wavelet.H >$@ par=${P}/mod.P nsrc=400


mod2.H: vel.H ${BMOD} wavelet.H mod.P
	Pad < vel.H >v.H extend=1 beg1=20 beg2=20 end1=150 end2=20
	Pad < dx.H >d.H extend=1 beg1=20 beg2=20 end1=150 end2=20
	Add scale=1,0.1 v.H d.H >v3.H
	${BMOD} velocity=v3.H density=d.H wavelet=wavelet.H >$@ par=mod.P nsrc=400 osrc=10.


cmp.H: mod.H 
	Create3d < mod.H >d.3d.H keyname1=offset keyname2=s_x
	Headermath <d.3d.H >m.3d.H key1=cmp_x key2=h_x eqn1="s_x+offset/2" eqn2="offset/2"
	Sort3d < m.3d.H >s.3d.H nkeys=2 key1=cmp_x key2=h_x og1=0 dg1=.0125 ng1=1600 og2=0 dg2=.0125 ng2=200 verb=1 debug=1
	Infill3d < s.3d.H >$@ maxsize=1000 verb=1 verbose=1


freq.H: cmp.H
	Window3d <cmp.H j2=2 j3=2 >x.H
	Transp < x.H plane=23 maxsize=1000>a.H
	echo d2=.05 >> a.H
	<a.H Mute tmute=.2 vmute=1.3 >y.H
	echo d2=.025 >> y.H
	Transp < y.H maxsize=1000 >x.H plane=23
	Transf maxsize=1000 < x.H >$@ is2d=y f_min=3 f_max=35


vel.mig.H: vel.H
	Transp < vel.H |Transp plane=23 >$@

sref.H: vel.mig.H
	Lloyd_vel < vel.mig.H >$@ nref=6

zero.H: sref.H vel.mig.H ${BMIG} freq.H
	Window3d squeeze=n < freq.H >f0.H n3=1
	${BMIG}  Data=f0.H R=$@ S=vel.mig.H ref_slow=sref.H  verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 nzb=200

mig.H: sref.H vel.mig.H ${BMIG} # freq.H
	Window3d < freq.H squeeze=n >f0.H n5=17 f5=0 
	Window3d < freq.H squeeze=n >f1.H n5=17 f5=17 
	Window3d < freq.H squeeze=n >f2.H n5=17 f5=34 
	Window3d < freq.H squeeze=n >f3.H n5=17 f5=51 
	Window3d < freq.H squeeze=n >f4.H n5=17 f5=68
	Window3d < freq.H squeeze=n >f5.H n5=17 f5=85 
	Window3d < freq.H squeeze=n >f6.H n5=17 f5=102 
	Window3d < freq.H squeeze=n >f7.H n5=17 f5=119
	${BMIG}  Data=f0.H R=r0.H S=vel.mig.H ref_slow=sref.H npad_mx=10 npad_hx=10  verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f1.H R=r1.H S=vel.mig.H ref_slow=sref.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f2.H R=r2.H S=vel.mig.H ref_slow=sref.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f3.H R=r3.H S=vel.mig.H ref_slow=sref.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f4.H R=r4.H S=vel.mig.H ref_slow=sref.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f5.H R=r5.H S=vel.mig.H ref_slow=sref.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500&
	${BMIG}  Data=f6.H R=r6.H S=vel.mig.H ref_slow=sref.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500&
	${BMIG}  Data=f7.H R=r7.H S=vel.mig.H ref_slow=sref.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500
	Add  r0.H r1.H r2.H r3.H r4.H r5.H r6.H r7.H >$@



vel.0.H: vel.H
	Smooth < vel.H >$@ rect2=500 rect1=30

mig.%.H: sref.H vel.%.H ${BMIG} # freq.H
	Window3d < freq.H squeeze=n >f0.H n5=17 f5=0 
	Window3d < freq.H squeeze=n >f1.H n5=17 f5=17 
	Window3d < freq.H squeeze=n >f2.H n5=17 f5=34 
	Window3d < freq.H squeeze=n >f3.H n5=17 f5=51 
	Window3d < freq.H squeeze=n >f4.H n5=17 f5=68
	Window3d < freq.H squeeze=n >f5.H n5=17 f5=85 
	Window3d < freq.H squeeze=n >f6.H n5=17 f5=102 
	Window3d < freq.H squeeze=n >f7.H n5=17 f5=119
	Transp < vel.$*.H |Transp plane=23 >v.H
	Lloyd_vel < v.H >sr.H nref=6
	${BMIG}  Data=f0.H R=r0.H S=v.H ref_slow=sr.H npad_mx=10 npad_hx=10  verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f1.H R=r1.H S=v.H ref_slow=sr.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f2.H R=r2.H S=v.H ref_slow=sr.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f3.H R=r3.H S=v.H ref_slow=sr.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f4.H R=r4.H S=v.H ref_slow=sr.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500 &
	${BMIG}  Data=f5.H R=r5.H S=v.H ref_slow=sr.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500&
	${BMIG}  Data=f6.H R=r6.H S=v.H ref_slow=sr.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500&
	${BMIG}  Data=f7.H R=r7.H S=v.H ref_slow=sr.H  npad_mx=10 npad_hx=10 verb=1 az__n=400 az__o=0 az__d=.012 nw_tot=500
	Add  r0.H r1.H r2.H r3.H r4.H r5.H r6.H r7.H >$@







