BX=../xgrad

dn= >/dev/null
grey=   Grey newclip=1 wantscalebar=1 bpclip=0 epclip=100 ${dn}
jgrey=  Grey newclip=1 wantscalebar=1 bpclip=0 epclip=100 color=j ${dn}
xgrey=  Grey newclip=1 wantscalebar=1 bpclip=0 epclip=100 ${dn}
pcgrey= Grey newclip=1 wantscalebar=1 bpclip=1 epclip=99 color=j ${dn}


lens_labels= " label1=t(s) label2=Distance(km) label3= o3=0 d3=1"
vel_labels=  label1="Depth(m)"  label2="Distance(m)" 
blank= title=" "


# Test on Marmousi Model
#----------------------------
marm-org-vel.H :
	Cp /data/marmousi/marmvel.H  $@
	echo  ${vel_labels} >>$@

marm-org-den.H :
	Cp /data/marmousi/marmdens.H  junkd.H
	Math file1=junkd.H exp="file1/1000." >$@
	echo  ${vel_labels} >>$@


marm-ref.H: marm-org-vel.H marm-org-den.H
	Add mode=mult  marm-org-vel.H  marm-org-den.H  >marm-imp.H 
	./NEW/reflect.x <marm-imp.H  >$@


marm-S0vel.H : marm-org-vel.H
	Smooth  <$<  rect1=10 rect2=10 >$@

marm-S0den.H : marm-org-den.H 
	Smooth  <$<  rect1=10 rect2=10 >$@


marm-S0prp.H: marm-S0vel.H
	Math file1=$< exp='file1/1000-2' >$@

marm-S1vel.H: marm-S0vel.H
	Smooth < $< rect1=30 rect2=1 >$@

marm-S2vel.H: marm-S0vel.H
	Smooth < $< rect1=30 rect2=15 >$@


marm-S%xg.H: marm-S%vel.H marm-S0prp.H 
	${BX}/Xgrad_it.x <marm-S$*vel.H aux=marm-S0prp.H >$@


marm-R%xg.H: marm-S%vel.H marm-ref.H
	${BX}/Xgrad_it.x <marm-S$*vel.H aux=marm-ref.H >$@


marm%vel.v: marm%vel.H 
	${jgrey} <$<  out=${R}/$@  ${blank} ${vel_labels}


marm%ref.v: marm%ref.H 
	${pcgrey} <$<  out=${R}/$@  ${blank} ${vel_labels}

marm%xg.v: marm%xg.H 
	${xgrey} <$<  out=${R}/$@  ${blank} ${vel_labels}  eclip=0.09 bclip=-0.09
	#eclip=2E-6 bclip=-2E-6 for xg


# NOISE TESTS
noise1.H: marm-S0vel.H
	Math file1=$< exp="0." > junk_0.H	
	Noise < junk_0.H type=0 mean=0. var=1. >junk_N1.H
	Math file1=junk_N1.H exp="file1*100." > junk_N2.H
	Smooth < junk_N2.H rect1=5 rect2=5 >$@



noise2.H: marm-S0vel.H
	Math file1=$< exp="0." > junk_0.H	
	Noise < junk_0.H type=1 mean=500. var=1. >junk_N1.H
	Smooth < junk_N1.H rect1=5 rect2=5 >$@



marm-N%vel.H: marm-S0vel.H noise%.H
	Add scale=1,1 noise$*.H  marm-S0vel.H  > $@

marm-NS%vel.H: marm-S2vel.H noise%.H
	Add scale=1,1 noise$*.H  marm-S2vel.H  > $@

marm-N%xg.H: marm-N%vel.H marm-S0vel.H
	${BX}/Xgrad_it.x <marm-N$*vel.H  aux=marm-S0vel.H >$@


marm-NS%xg.H: marm-NS%vel.H marm-S0vel.H
	${BX}/Xgrad_it.x <marm-NS$*vel.H  aux=marm-S0vel.H >$@

noise%.v: noise%.H 
	${jgrey} <$<  ${dn} out=${R}/$@  title="Additive noise" ${vel_labels} eclip=1 bclip=-1


marm-allvel.v:marm-S0vel.H marm-S1vel.H marm-S2vel.H
	${fgrey} <marm-S0vel.H title="Marmousi Velocity"  out=${R}/marm-S0vel.v ${blank} ${vel_labels}
	${fgrey} <marm-S1vel.H  title="Smooth1 Marmousi Velocity"  out=${R}/marm-S1vel.v ${blank} ${vel_labels}
	${fgrey} <marm-S2vel.H  title="Smooth2 Marmousi Velocity"  out=${R}/marm-S2vel.v ${blank} ${vel_labels}
	vp_Movie ${R}/marm-S0vel.v ${R}/marm-S1vel.v ${R}/marm-S2vel.v >${R}/$@


marm-allxg.v: marm-S0xg.H  marm-S1xg.H  marm-S2xg.H
	${grey} < marm-S0xg.H title="XGradients For Marmousi"  out=${R}/marm-S0xg.v ${blank}
	${grey} < marm-S1xg.H title="XGradients For Smooth1 Marmousi" out=${R}/marm-S1xg.v ${blank}
	${grey} < marm-S2xg.H title="XGradients For Smooth2 Marmousi" out=${R}/marm-S2xg.v ${blank}
	vp_Movie ${R}/marm-S0xg.v ${R}/marm-S1xg.v ${R}/marm-S2xg.v > ${R}/$@









# Test on Pillow Model
#----------------------------
pilw-S0vel.H :
	Cp /data/pillow/velo.H  junkv.H
	echo  ${vel_labels} >>junkv.H
	Smooth  <junkv.H rect1=20 rect2=20 >$@

pilw-S0prp.H: pilw-S0vel.H
	Cp $< junk1.H
	Math file1=junk1.H exp='file1/1000-2' >$@

pilw-S1vel.H: pilw-S0vel.H
	Smooth < $< rect1=50 rect2=1 >$@

pilw-S2vel.H: pilw-S0vel.H
	Smooth < $< rect1=50 rect2=25 >$@

pilw-S%xg.H: pilw-S%vel.H pilw-S0prp.H
	${BX}/Xgrad_it.x <pilw-S$*vel.H aux=pilw-S0prp.H >$@


pilw%vel.v: pilw%vel.H 
	${grey} <pilw$*vel.H  out=${R}/pilw$*vel.v  ${blank} ${vel_labels}

pilw%xg.v: pilw%xg.H 
	${xgrey} <pilw$*xg.H  out=${R}/pilw$*xg.v  ${blank}

pilw-allvel.v: pilw-S0vel.H pilw-S1vel.H pilw-S2vel.H
	${fgrey} <pilw-S0vel.H title="Pillow Velocity"  out=${R}/pilw-S0vel.v  ${blank} ${vel_labels}
	${fgrey} <pilw-S1vel.H  title="Smooth1 Pillow Velocity"  out=${R}/pilw-S1vel.v ${blank} ${vel_labels}
	${fgrey} <pilw-S2vel.H  title="Smooth2 Pillow Velocity"  out=${R}/pilw-S2vel.v ${blank} ${vel_labels}
	vp_Movie ${R}/pilw-S0vel.v ${R}/pilw-S1vel.v ${R}/pilw-S2vel.v >${R}/$@


pilw-allxg.v: pilw-S0xg.H  pilw-S1xg.H  pilw-S2xg.H
	${grey} < pilw-S0xg.H title="XGradients For Pillow"  out=${R}/pilw-S0xg.v ${blank}
	${grey} < pilw-S1xg.H title="XGradients For Smooth1 Pillow" out=${R}/pilw-S1xg.v ${blank}
	${grey} < pilw-S2xg.H title="XGradients For Smooth2 Pillow" out=${R}/pilw-S2xg.v ${blank}
	vp_Movie ${R}/pilw-S0xg.v ${R}/pilw-S1xg.v ${R}/pilw-S2xg.v >${R}/$@




